Sign in

Quickstart - Get started with Liveblocks, CodeMirror, Yjs, and Vue.js

Liveblocks is a realtime collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your Vue.js application using the APIs from the @liveblocks/yjs package.

Quickstart

  1. Install Liveblocks, Yjs, and CodeMirror

    Every Liveblocks package should use the same version.

    $npm install @liveblocks/client @liveblocks/yjs yjs codemirror @codemirror/lang-javascript y-codemirror.next
  2. Initialize the liveblocks.config.ts file

    We can use this file later to define types for our application.

    $npx create-liveblocks-app@latest --init --framework javascript
  3. Set up your collaborative CodeMirror code editor

    Editor.vue
    <script setup>import { ref, onMounted, onUnmounted } from "vue";import { createClient } from "@liveblocks/client";import { getYjsProviderForRoom } from "@liveblocks/yjs";import * as Y from "yjs";import { yCollab } from "y-codemirror.next";import { EditorView, basicSetup } from "codemirror";import { EditorState } from "@codemirror/state";import { javascript } from "@codemirror/lang-javascript";
    const parent = ref(null);const leave = ref(null);const view = ref(null);
    // Set up Liveblocks clientconst client = createClient({ publicApiKey: "",});
    // Enter a multiplayer roomconst info = client.enterRoom("my-room");const room = info.room;leave.value = info.leave;
    // Set up Yjs document, shared text, and Liveblocks Yjs providerconst yProvider = getYjsProviderForRoom(room);const yDoc = yProvider.getYDoc();const yText = yDoc.getText("codemirror");
    onMounted(() => { // Set up CodeMirror and extensions const state = EditorState.create({ doc: yText.toString(), extensions: [ basicSetup, javascript(), yCollab(yText, yProvider.awareness, { undoManager }), ], });
    // Attach CodeMirror to element view.current = new EditorView({ state, parent: parent.value, });});
    onUnmounted(() => { view?.destroy(); leave.value?.();});</script>
    <template> <div ref="parent" /></template>
  4. Next: set up authentication

    By default, Liveblocks is configured to work without an authentication endpoint where everyone automatically has access to rooms. This approach is great for prototyping and marketing pages where setting up your own security isn’t always required. If you want to limit access to a room for certain users, you’ll need to set up an authentication endpoint to enable permissions.

    Set up authentication

What to read next

Congratulations! You now have set up the foundation for your collaborative CodeMirror code editor inside your Vue.js application.

We use cookies to collect data to improve your experience on our site. Read our Privacy Policy to learn more.

Sign in

Quickstart - Get started with Liveblocks, CodeMirror, Yjs, and React

Liveblocks is a realtime collaboration infrastructure for building performant collaborative experiences. Follow the following steps to start adding collaboration to your React application using the APIs from the @liveblocks/yjs package.

Quickstart

  1. Install Liveblocks, Yjs, and CodeMirror

    Every Liveblocks package should use the same version.

    $npm install @liveblocks/client @liveblocks/react @liveblocks/yjs yjs codemirror @codemirror/lang-javascript y-codemirror.next
  2. Initialize the liveblocks.config.ts file

    We can use this file later to define types for our application.

    $npx create-liveblocks-app@latest --init --framework react
  3. Set up the Liveblocks client

    Liveblocks uses the concept of rooms, separate virtual spaces where people collaborate, and to create a realtime experience, multiple users must be connected to the same room. Set up a Liveblocks client with LiveblocksProvider, and join a room with RoomProvider.

    App.tsx
    "use client";
    import { LiveblocksProvider, RoomProvider,} from "@liveblocks/react/suspense";import { Editor } from "./Editor";
    export default function App() { return ( <LiveblocksProvider publicApiKey={""}> <RoomProvider id="my-room"> {/* ... */} </RoomProvider> </LiveblocksProvider> );}
  4. Join a Liveblocks room

    After setting up the room, you can add collaborative components inside it, using ClientSideSuspense to add loading spinners to your app.

    App.tsx
    "use client";
    import { LiveblocksProvider, RoomProvider, ClientSideSuspense,} from "@liveblocks/react/suspense";import { Editor } from "./Editor";
    export default function App() { return ( <LiveblocksProvider publicApiKey={""}> <RoomProvider id="my-room"> <ClientSideSuspense fallback={<div>Loading…</div>}> <Editor /> </ClientSideSuspense> </RoomProvider> </LiveblocksProvider> );}
  5. Set up the collaborative CodeMirror editor

    Now that we set up Liveblocks, we can start integrating CodeMirror and Yjs in the Editor.tsx file. To make the editor collaborative, we can rely on the yCollab from y-codemirror.next.

    "use client";
    import * as Y from "yjs";import { yCollab } from "y-codemirror.next";import { EditorView, basicSetup } from "codemirror";import { EditorState } from "@codemirror/state";import { javascript } from "@codemirror/lang-javascript";import { useCallback, useEffect, useState } from "react";import { getYjsProviderForRoom } from "@liveblocks/yjs";import { useRoom } from "@/liveblocks.config";import styles from "./Editor.module.css";
    export default function Editor() { const room = useRoom(); const yProvider = getYjsProviderForRoom(room); const [element, setElement] = useState<HTMLElement>();
    const ref = useCallback((node: HTMLElement | null) => { if (!node) return;
    setElement(node); }, []);
    // Set up Liveblocks Yjs provider and attach CodeMirror editor useEffect(() => { let view: EditorView;
    if (!element || !room) { return; }
    // Get document const yDoc = yProvider.getYDoc(); const yText = yDoc.getText("codemirror"); const undoManager = new Y.UndoManager(yText);
    // Set up CodeMirror and extensions const state = EditorState.create({ doc: yText.toString(), extensions: [ basicSetup, javascript(), yCollab(yText, yProvider.awareness, { undoManager }), ], });
    // Attach CodeMirror to element view = new EditorView({ state, parent: element, });
    return () => { view?.destroy(); }; }, [element, room]);
    return <div ref={ref} className={styles.editor} />;}
  6. Next: set up authentication

    By default, Liveblocks is configured to work without an authentication endpoint where everyone automatically has access to rooms. This approach is great for prototyping and marketing pages where setting up your own security isn’t always required. If you want to limit access to a room for certain users, you’ll need to set up an authentication endpoint to enable permissions.

    Set up authentication

What to read next

Congratulations! You now have set up the foundation for your collaborative CodeMirror editor inside your React application.


Examples using CodeMirror

We use cookies to collect data to improve your experience on our site. Read our Privacy Policy to learn more.